"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Program(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_0 import opencb as opencb_1_3_1

        return {
            "org.opencb.biodata.models.metadata.Program": opencb_1_3_1.Program,
        }

    __slots__ = [
        "commandLine",
        "commit",
        "name",
        "url",
        "version",
    ]

    def __init__(
        self,
        commandLine=None,
        commit=None,
        name=None,
        url=None,
        version=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_1.Program model.

        :param commandLine:
        :type commandLine: None | str
        :param commit:
        :type commit: None | str
        :param name:
        :type name: None | str
        :param url:
        :type url: None | str
        :param version:
        :type version: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.1"
